type compare_result =
  | LESS
  | EQUAL
  | GREATER

module type ORDERED_SET =
sig
  type t
  val compare : t->t->compare_result
end

module Make(Codomain : ORDERED_SET) =
struct
  type key = Codomain.t
  let compare = Codomain.compare
