  let add : key -> 'a -> 'a t -> 'a t = fun k v t ->
     coqadd t k v

  let find : key -> 'a t -> 'a = fun v t ->
     match (coqfind t v) with
       None -> raise Not_found
     | Some x -> x

  let mem : key -> 'a t -> bool = fun v t ->
     match (coqfind t v) with
       None -> false
     | Some _ -> true

  let remove : key -> 'a t -> 'a t = fun k v ->
     coqremove v k
end
